program Prepare2;

uses SQLite3, GPC;

var
  Err, v1, v2: TString;
  MyDb: TSQLite3;
  Stmnt: TSQLite3Statement;
  Count, ColType, i: Integer;

procedure Step (Stmnt: TSQLite3Statement);
var Ret: Integer;
begin
  Ret := SQLite3Step (Stmnt);
  if Ret = SQLITE_BUSY then
    WriteLn ('SQLITE_Busy')
  else if Ret = SQLITE_DONE then
    WriteLn ('SQLITE_Done')
  else if Ret = SQLITE_ROW then
    WriteLn ('SQLITE_Row')
  else if Ret = SQLITE_ERROR then
    WriteLn ('SQLITE_ERROR')
  else if Ret = SQLITE_MISUSE then 
    WriteLn ('SQLITE_Misuse');
end;


begin
  if SQLite3Open ('prepare2.db', MyDb) = SQLITE_OK then
    begin
      Write ('Database ''prepare2.db'' successfully opened. Now we create the database with ''SQLite3Exec''...');
      if SQLite3Exec (MyDb, 'CREATE TABLE animals (name TEXT, type TEXT);', nil, nil, Err) <> SQLITE_OK then
        begin
          WriteLn;
          WriteLn ('ERROR: ', Err)
        end;
      WriteLn ('done.');
      Write ('We prepare INSERT...');
      if SQLite3Prepare (MyDb, 'INSERT INTO animals VALUES ($col,$value)', -1, Stmnt, Err) <> SQLITE_OK then
        begin
          WriteLn ('ERROR: Cannot prepare statement: ', Err);
          Halt
        end;
      WriteLn ('done.');
      Write ('Binding begins... ');
      v1 := 'Felix';
      v2 := 'Hamster';
      if SQLite3BindText (Stmnt, 1, v1, -1, Pointer (-1)) <> SQLITE_OK then
        begin
          WriteLn ('ERROR: Cannot bind 1');
          Halt
        end;
      if SQLite3BindText (Stmnt, 2, v2, -1, Pointer (-1)) <> SQLITE_OK then
        begin
          WriteLn ('ERROR: Cannot bind 2');
          Halt
        end;
      Step (Stmnt);
      WriteLn ('done. Now, we produce an error, just to see how it works...');
      if SQLite3BindText (Stmnt, 1, v1, -1, Pointer (-1)) <> SQLITE_OK then
        WriteLn ('ERROR: ', SQLite3ErrMsg (MyDb));
      SQLite3Finalize (Stmnt);
      Write ('We prepare SELECT...');
      if SQLite3Prepare (MyDb, 'SELECT * FROM animals WHERE name=$name', -1, Stmnt, Err) <> SQLITE_OK then
        begin
          WriteLn ('ERROR: Cannot prepare SELECT statement: ', Err);
          Halt
        end;
      WriteLn ('done.');
      if SQLite3BindText (Stmnt, 1, 'Felix', -1, Pointer (-1)) <> SQLITE_OK then
        begin
          WriteLn ('ERROR: Cannot bind to SELECT');
          Halt
        end;
      Step (Stmnt);
      Count := SQLite3DataCount (Stmnt);
      WriteLn ('There are ', Count, ' values waiting...');
      for i := 0 to Count - 1 do
        begin
          ColType := SQLite3ColumnType (Stmnt, i);
          Write ('Column ', i, ')  TITLE ''', SQLite3ColumnName (Stmnt, i), ''', ');
          Write (' DeclType=''', SQLite3ColumnDecltype (Stmnt, i), ''', ');
          if ColType = SQLITE_INTEGER then
            WriteLn ('TYPE ', ' is INTEGER.')
          else if ColType = SQLITE_FLOAT then
            WriteLn ('TYPE ', ' is FLOAT. ')
          else if ColType = SQLITE_TEXT then
            begin
              Write ('TYPE ', ' is TEXT ');
              WriteLn ('VALUE: ', SQLite3ColumnText (Stmnt, i))
            end
          else if ColType = SQLITE_BLOB then
            WriteLn ('TYPE ', ' is BLOB. ')
          else if ColType = SQLITE_NULL then
            WriteLn ('TYPE ', ' is NULL.');
        end;
        
    end
  else
    begin
      WriteLn ('ERROR: Something wrong, cannot open database');
      Halt 
    end;
  SQLite3Close (MyDb)
end.
