program Simple;

uses SQLite3, GPC;

var
  Err: TString;
  MyDb: TSQLite3;
  TableData: PStringSchema;
  Rows, Cols, i: Integer;

function Callback (Arg: Pointer; NumCol: Integer; ColVals, ColNames: PStringSchema): Integer;
var i: Integer;
begin
  Discard (Arg);
  Discard (NumCol);
  Discard (ColNames);
  for i := 1 to ColVals^.Num do
    Write  ('  ', ColVals^[i],  ' | ');
  WriteLn;
  Callback := 0
end;

begin
  WriteLn ('This SQLite3 version is: ', SQLite3Libversion);
  if SQLite3Open ('simple.db', MyDb) = SQLITE_OK then
    begin
      Write ('Database ''simple.db'' successfully opened. Now we insert some data with ''SQLite3Exec''...');
      if SQLite3Exec (MyDb, 'CREATE TABLE animals (name text, type text); INSERT INTO animals VALUES (''Felix'', ''Hamster'');INSERT INTO animals VALUES (''Piti'', ''Bird'');', Nil, Nil, Err) <> SQLITE_OK then
        begin
          WriteLn;
          WriteLn ('ERROR: ', Err)
        end;
      WriteLn ('done.');
      WriteLn ('Now I show you something with ''SQLite3GetTable''... ');
      SQLite3Exec (MyDb, 'SELECT * FROM animals;', @Callback, Nil, Err);
      WriteLn ('done.');
      WriteLn ('Now, lets do it again...');

      { Please note, that "Rows" only counts data rows. There is one more row for headers in the data set }
      SQLite3GetTable (MyDb, 'SELECT * FROM animals', TableData, Rows, Cols, Err);
      WriteLn ('There are ', Rows, ' data rows and ', Cols, ' column');
      WriteLn ('We pretty-print using ''SQLite3GetTable''... ;-)');
      for i := 1 to (Rows + 1) * Cols do
        begin
          Write (TableData^[i] : 10, ' | ');
          if i mod Cols = 0 then
            WriteLn
        end;
      SQLite3FreeTable (TableData)
    end
  else
    begin
      WriteLn ('ERROR: Something wrong, cannot open database');
      Halt 
    end;
  SQLite3Close (MyDb)
end.
